routes/web.php
<?php
use Chartisan\PHP\Chartisan;
use App\Charts\TransaksiChart;
use Charts as ch;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Route::middleware(['auth:sanctum', 'verified'])->get('/dashboard', function () {
    $totalProduk = count(App\Models\Produk::all());
    $totalCustomer = count(App\Models\Customer::all());
    $totalTransaksi = count(App\Models\Transaksi::all());
    $transaksi = App\Models\Transaksi::orderBy('created_at', 'desc')->get()
    ->groupBy(function($date) {
        return \Carbon\Carbon::parse($date->created_at)->format('M/y'); // grouping by years
        // return \Carbon\Carbon::parse($date->created_at)->format('m'); // grouping by months
    })->take(12);
// return $transaksi;
    $transaksiVal = array();
    $transaksiRange = array();

    foreach ($transaksi as $key => $value) {
        array_push($transaksiVal, $value->count());
        array_push($transaksiRange, $key);
    }

    $produkLabel = array();
    $produkData = array();

    $favList = DB::select('select nama, sum(rincian_transaksi.qty) as jumlah from rincian_transaksi right join produk on produk.id = rincian_transaksi.produk_id  where produk.deleted_at is null group by produk.nama order by produk.id asc');
// return $favList;

    foreach ($favList as $value) {
        array_push($produkLabel, $value->nama);
        array_push($produkData, $value->jumlah);
    }

    // return $produkData;
    return view('dashboard', ['totalProduk' => $totalProduk, 'totalCustomer' => $totalCustomer, 'totalTransaksi' => $totalTransaksi, 'transaksiVal' => $transaksiVal, 'transaksiRange' => $transaksiRange, 'produkLabel' => $produkLabel, 'produkData' => $produkData]);
})->name('dashboard');

Route::resource('produk', 'App\Http\Controllers\ProdukController')->middleware(['auth:sanctum', 'verified']);
Route::resource('customer', 'App\Http\Controllers\CustomerController')->middleware(['auth:sanctum', 'verified']);
Route::resource('transaksi', 'App\Http\Controllers\TransaksiController')->middleware(['auth:sanctum', 'verified']);
Route::post('transaksirinci/{request}/{idTransaksi}', 'App\Http\Controllers\RincianTransaksiController@store')->middleware(['auth:sanctum', 'verified'])->name('transaksirinci.store');
Route::get('transaksi/cetak-nota/{nomor}', 'App\Http\Controllers\TransaksiController@cetak')->middleware(['auth:sanctum', 'verified'])->name('transaksi.cetak');
Route::resource('laporan', 'App\Http\Controllers\LaporanController')->middleware(['auth:sanctum', 'verified']);
Route::resource('kabupaten', 'App\Http\Controllers\KabupatenController')->middleware(['auth:sanctum', 'verified']);
Route::resource('kelurahan', 'App\Http\Controllers\KelurahanController')->middleware(['auth:sanctum', 'verified']);
Route::resource('ongkir', 'App\Http\Controllers\OngkirController')->middleware(['auth:sanctum', 'verified']);
Route::resource('konfigurasi', 'App\Http\Controllers\KonfigurasiController')->middleware(['auth:sanctum', 'verified']);

// Sampah
Route::middleware(['auth:sanctum', 'verified'])->get('sampah', function(){
    $data = ($_GET['jenis'] == 'produk') ? \App\Models\Produk::onlyTrashed()->orderBy('deleted_at', 'desc')->get() : \App\Models\Customer::onlyTrashed()->orderBy('deleted_at', 'desc')->get();
    return view('sampah', ['data' => $data, 'jenis' => $_GET['jenis']]);
})->name('sampah');
Route::get('sampah/restore', function(){
    $data = ($_GET['jenis'] == 'produk') ? \App\Models\Produk::onlyTrashed()->where('id', $_GET['id'])->first() : \App\Models\Customer::onlyTrashed()->where('id', $_GET['id'])->first();
    $data->restore();
    return redirect()->route('sampah', ['jenis' => $_GET['jenis']])->with('success', ucfirst($_GET['jenis']).' '. $data->nama .' berhasil di kembalikan!');
})->name('restore.sampah')->middleware(['auth:sanctum', 'verified']);

app/Models/Kabupaten.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Kabupaten extends Model
{
    use HasFactory;
    use SoftDeletes;
    protected $table = "Kabupaten";

    public function kelurahan()
    {
        return $this->hasMany('App\Models\Kelurahan', 'id', 'kabupaten_id');
    }
}

app/Http/Controllers/KabupatenController.php
<?php

namespace App\Http\Controllers;

use App\Models\Kabupaten;
use Illuminate\Http\Request;

class KabupatenController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('kabupaten.index', ['data' => Kabupaten::all()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('kabupaten.create', ['submitbuttontext' => 'Tambah']);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $newData = new Kabupaten();
        $newData->nama = $request->nama;
        $newData->save();

        return redirect()->route('kabupaten.index')->with('success', 'Kabupaten '. $newData->nama .' berhasil dibuat.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Kabupaten  $kabupaten
     * @return \Illuminate\Http\Response
     */
    public function show(Kabupaten $kabupaten)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Kabupaten  $kabupaten
     * @return \Illuminate\Http\Response
     */
    public function edit($nama)
    {
        return view('kabupaten.edit', ['data' => Kabupaten::where('nama', $nama)->first(), 'submitbuttontext' => 'Ubah']);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Kabupaten  $kabupaten
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $oldData = Kabupaten::where('id', $id)->first();
        $nama = $oldData->nama;
        $oldData->nama = $request->nama;
        $oldData->save();

        return redirect()->route('kabupaten.index')->with('success', 'Kabupaten '. $nama .' menjadi '. $oldData->nama .' berhasil diubah.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Kabupaten  $kabupaten
     * @return \Illuminate\Http\Response
     */
    public function destroy($nama)
    {
        $data = Kabupaten::where('nama', $nama)->first();
        $data->delete();

        return back()->with('danger', 'Kabupaten '. $nama .' berhasil dihapus.');
    }
}

resources/views/kabupaten/create.blade.php
@extends('layouts.template')
@section('title', 'Tambah Kabupaten | Admin')
@section('contentHeader', 'Tambah Kabupaten')
@section('breadCrumb')
    <li class="breadcrumb-item"><a href="{{ route('produk.index') }}">Data Kabupaten</a></li>
    <li class="breadcrumb-item active">Tambah Data</li>
@endsection

@section('content')
<!-- Main content -->
    <div class="container-fluid">
      <!-- Small boxes (Stat box) -->
      <div class="row">
        <div class="col-lg-12 bg-gray disabled rounded">
            <div class="card-body">
                {!! Form::open(['method' => 'POST', 'action' => 'App\Http\Controllers\KabupatenController@store', 'id' => 'kelas_create_form']) !!}
                @csrf
                @include('kabupaten.form')
            </div>
        </div>
      </div>
      <!-- /.row (main row) -->
    </div><!-- /.container-fluid -->
  <!-- /.content -->
@endsection

resources/views/kabupaten/edit.blade.php
@extends('layouts.template')
@section('title', 'Ubah Kabupaten | Admin')
@section('contentHeader', 'Ubah Kabupaten')
@section('breadCrumb')
    <li class="breadcrumb-item"><a href="{{ route('kabupaten.index') }}">Data Kabupaten</a></li>
    <li class="breadcrumb-item active">Ubah Data</li>
@endsection

@section('content')
<!-- Main content -->
    <div class="container-fluid">
      <!-- Small boxes (Stat box) -->
      <div class="row">
        <div class="col-lg-12 bg-gray disabled rounded">
            <div class="card-body">
                {!! Form::model($data, ['method' => 'PATCH', 'action' => ['App\Http\Controllers\KabupatenController@update',$data->id], 'id' => 'kelas_create_form']) !!}
                {{-- @csrf --}}
                @include('kabupaten.form')
            </div>
        </div>
      </div>
      <!-- /.row (main row) -->
    </div><!-- /.container-fluid -->
  <!-- /.content -->
@endsection

resources/views/kabupaten/form.blade.php
<div class="form-group">
    {!! Form::label('nama', 'Nama: ') !!}
    {!! Form::text('nama', null, ['class' => 'form-control', 'required']) !!}
    @if ($errors->has('nama'))
        <span class="text-danger">{{ $errors->first('nama') }}</span>
    @endif
</div>
{!! Form::submit($submitbuttontext, ['class' => 'btn btn-md btn-success']) !!}
{!! Form::close() !!}

resources/views/kabupaten/index.blade.php
@extends('layouts.template')
@section('title', 'Data Kabupaten | Admin')
@section('contentHeader', 'Data Kabupaten')
@section('breadCrumb')
    <li class="breadcrumb-item active">Data Kabupaten</li>
@endsection

@section('content')
{{-- content --}}
    <div class="container-fluid bg-secondary rounded">
    <!-- Small boxes (Stat box) -->
      <div class="row pt-4">
          <div class="col-lg-6">
            <a href="{{ route('kabupaten.create') }}" class="btn btn-md btn-primary">Tambah Kabupaten</a>
          </div>
      </div>
      <div class="row mt-3 p-2">
        <div class="col-lg-12 p-4 bg-light rounded">
            <table id="tableData" class="table table-striped table-hover table-bordered dt-responsive nowrap" style="width:100%">
                <thead>
                    <tr>
                        <th>No</th>
                        <th>Kabupaten</th>
                        <th>Aksi</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($data as $index => $each)
                        <tr>
                            <td>{{ $index+1 }}</td>
                            <td>{{ $each->nama }}</td>
                            <td>
                                <a href="{{ route('kabupaten.edit', $each->nama) }}" class="btn btn-sm btn-warning">
                                    <i class="fas fa-pen"></i>
                                </a>
                                <form action="{{ route('kabupaten.destroy', $each->nama) }}" method="post" style="display:inline">
                                    @csrf
                                    @method('DELETE')
                                    <button class="btn btn-sm btn-danger btn-delete">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
      </div>
    </div><!-- /.container-fluid -->
{{-- endcontent --}}
@endsection